import React, { Component } from 'react';
import './datagrid.css';


const TableSection = ({ data, metadata, styleData }) => {
  if (!data || !data.length) {
    console.log(styleData.width);
    console.log(styleData);
    return null;
  }
  return (
    <div className="data-grid" style={styleData.gridWrapper}>
      <div className="content" style={styleData.gridContent} >
        <div className="table" >
          <table style={styleData.gridTable}>
            <thead style={styleData.gridTableThead}>
              <tr className="total-record-row" style={styleData.gridTableTR}>
                <th colSpan="4" style={styleData.gridTableTH}>
                  {data.length} RECORDS
                </th>
              </tr>
              <tr className="table-header" style={styleData.gridTableTR}>
                <TableHeader metadata={metadata} styleData={styleData} />
              </tr>
            </thead>
            <tbody style={styleData.gridTableTbody}>
              <TableBody tableData={data} metadata={metadata} styleData={styleData} />
            </tbody>
          </table>
        </div>
      </div>
    </div>
  );
};

const TableHeader = ({ metadata, styleData }) => metadata.map(colMetaDataHeader => <HeaderRow metadata={colMetaDataHeader} styleData={styleData} key={colMetaDataHeader.name} />);

const HeaderRow = ({ metadata, styleData }) => (
  <th style={styleData.gridTableTH}>{metadata.name}</th>
);

const TableBody = ({ tableData, metadata, styleData }) => {
  if (!tableData) {
    return null;
  }
  return tableData.map(rowData => <Row data={rowData} metadata={metadata} styleData={styleData} key={rowData.companyId} />);
};

const Row = ({ data, metadata, styleData }) => (
  <tr style={styleData.gridTableTR}>
    {metadata.map(colMetaData => <RowColumn value={data[colMetaData.key]} styleData={styleData} key={colMetaData.key} />)}
  </tr>
);

const RowColumn = ({ value, styleData }) => (
  <td style={styleData.gridTableTD}>{value}</td>
);

class DataGrid extends Component {
  constructor(props) {
    super(props);
  }
  render() {
    return <TableSection data={this.props.data} metadata={this.props.metadata} styleData={this.props.styleData} />;
  }
}


export default DataGrid;
